Thursday, August 30, 2018

403. Frog Jump

403Frog Jump
A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.
Given a list of stones' positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.
If the frog's last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.
Note:
  • The number of stones is ≥ 2 and is < 1,100.
  • Each stone's position will be a non-negative integer < 231.
  • The first stone's position is always 0.
Example 1:
[0,1,3,5,6,8,12,17]

There are a total of 8 stones.
The first stone at the 0th unit, second stone at the 1st unit,
third stone at the 3rd unit, and so on...
The last stone at the 17th unit.

Return true. The frog can jump to the last stone by jumping 
1 unit to the 2nd stone, then 2 units to the 3rd stone, then 
2 units to the 4th stone, then 3 units to the 6th stone, 
4 units to the 7th stone, and 5 units to the 8th stone.
Example 2:
[0,1,2,3,4,8,9,11]

Return false. There is no way to jump to the last stone as 
the gap between the 5th and 6th stone is too large.
--------------------------------
Solution #1, brute force. Time limit exceeded
O(3^n)
class Solution {
    public boolean canCross(int[] stones) {
        Map<Integer, Integer> map = getMap(stones);
        return rec(map, stones, 1, 1);
    }
    
    private boolean rec(Map<Integer, Integer> map, int[] stones, int stone, int k) {
        if (k == 0 || !map.containsKey(stone)) return false;
        if (map.get(stone) == stones.length - 1) return true;
        
        return rec(map, stones, stone + k - 1, k - 1)
            || rec(map, stones, stone + k, k)
            || rec(map, stones, stone + k + 1, k + 1);
    }
    
    private Map<Integer, Integer> getMap(int[] stones) {
        Map<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < stones.length; i++) {
            map.put(stones[i], i);
        }
        
        return map;
    }
}

Solution #2, DP - Memoization
O(n^2 * m), m为计算key的复杂度,ToDo: java这块转换代码的实现和复杂度得深入了解下
如果用一些hashing算法的话,应该可以把m压缩到O(1), 这样总体保持O(n^2)
或者(ToDo),用一个n * n的2d array,n为stone的数量。因为步数k肯定会是小于总的stone的数量
class Solution {
    public boolean canCross(int[] stones) {
        Map<Integer, Integer> map = getMap(stones);
        Map<String, Boolean> dp = new HashMap<>();
        return rec(map, stones, 1, 1, dp);
    }
    
    private boolean rec(Map<Integer, Integer> map, int[] stones, int stone, int k, Map<String, Boolean> dp) {
        if (k == 0 || !map.containsKey(stone)) return false;
        if (map.get(stone) == stones.length - 1) return true;
        
        String key = Integer.toString(stone) + "#" + Integer.toString(k);
        if (dp.containsKey(key)) {
            return dp.get(key);
        }
        
        boolean flag = rec(map, stones, stone + k - 1, k - 1, dp)
            || rec(map, stones, stone + k, k, dp)
            || rec(map, stones, stone + k + 1, k + 1, dp);
        
        dp.put(key,flag);
        return flag;
    }
    
    private Map<Integer, Integer> getMap(int[] stones) {
        Map<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < stones.length; i++) {
            map.put(stones[i], i);
        }
        
        return map;
    }
}
Solution #3, iterative DP. 用#2的思路,但是第2维存的是Set,因为要保证唯一性
Map里存的是(stone -> 到达当前stone上一步所用的step). 画一个2维矩阵图能帮助理解,这里就懒得发上来了。
class Solution {
    public boolean canCross(int[] stones) {
        Map<Integer, Set<Integer>> map = getMap(stones);
        
        if (!map.containsKey(1)) return false;
        map.get(1).add(1);
        for (int i = 1; i < stones.length - 1; i++) {
            
            int stone = stones[i];
            for (Integer step : map.get(stone)) {
                if (step - 1 > 0 && map.containsKey(stone + step - 1)) {
                    map.get(stone + step - 1).add(step - 1);
                }
                if (map.containsKey(stone + step)) {
                    map.get(stone + step).add(step);
                }
                if (map.containsKey(stone + step + 1)) {
                    map.get(stone + step + 1).add(step + 1);
                }
            }
        }
        
        return !map.get(stones[stones.length - 1]).isEmpty();
    }
    
    private Map<Integer, Set<Integer>> getMap(int[] stones) {
        Map<Integer, Set<Integer>> map = new HashMap<>();
        for (int stone : stones) {
            map.put(stone, new HashSet<>());
        }
        
        return map;
    }
}

No comments:

Post a Comment